/*
Scrivere un programma per la gestione delle operazioni presso una banca online. 
Ogni operazione  caratterizzata dalle seguenti informazioni: 
numero conto corrente, codice tipo di operazione, importo, codice operazione (codice numerico), data operazione.
Le operazioni sono organizzate in memoria come un vettore con 40 elementi.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1) Lettura da file e copia nel vettore delle operazioni;
2) Inserimento di una nuova operazione;
3) Cancellazione di unoperazione (chiedere il codice operazione);
4) Visualizzazione delle operazioni di un certo giorno (chiedere la data);
5) Salvataggio su file delle operazioni.

*/


#include<stdio.h>
#include<string.h>

struct operaz{
       int numero;
       int tipo;
       float importo;
       int codice;
       char data[12];
       };
       
void lettura(struct operaz *V,int *pn){
     int i;
     FILE *pf;
     struct operaz o;
     
     i=0;
    
     pf=fopen("operazioni.dat","rb");
     if(pf){
            while(i<40 && fread(&o,sizeof(struct operaz),1,pf)>0)
            {
              V[i]=o;
              i++;
            }
            fclose(pf);
            }
     
     else printf("Errore in lettura!\n");
     
     *pn=i;
     }


void inserimento(struct operaz *V,int *pn){
     struct operaz o;
     
     if(*pn<40){
                printf("Numero conto corrente: ");
                scanf("%d",&o.numero);
                
                printf("Codice tipo operazione (1=prelievo ; 2=versamento ; 3=saldo): ");
                scanf("%d",&o.tipo);
                
                printf("Importo: ");
                scanf("%f",&o.importo);
                
                printf("Codice operazione (numerico): ");
                scanf("%d",&o.codice);
               
                printf("Data dell'operazione (gg/mm/aaaa): ");
                scanf("%s",o.data);
                
                V[*pn]=o;
                (*pn)++;
                }
     else printf("Vettore pieno!\n");
     }
     
void cancella(struct operaz *V,int *pn){
     int i,p;
     int codice;
     
     printf("Inserire il codice dell'operazione da cancellare: ");
     scanf("%d",&codice);
     
     for(p=0;p<*pn;p++)
     if(V[p].codice==codice)
        break;
     
     if(p<*pn){
               for(i=p;i<*pn-1;i++)
               V[i]=V[i+1];
               (*pn)--;
               printf("Operazione cancellata!\n");
               }
     
     else printf("Nessuna operazione trovata!");
     }
     
void visualizza(struct operaz *V,int n){
     int i;
     char data[12];   
     
     
     printf("Visualizza operazioni relative al (gg/mm/aaaa): ");
     scanf("%s",data);
     
     for(i=0;i<n;i++)
     if(strcmp(V[i].data,data)==0){
                                   printf("Numero conto corrente: %d\n",V[i].numero);
                                   printf("Codice tipo di operazione: %d\n",V[i].tipo);
                                   printf("Importo: %f\n",V[i].importo);
                                   printf("Codice operazione: %d\n\n",V[i].codice);
                                   }
     }
     
void salva(struct operaz *V,int n){
     int i;
     FILE *pf;
     
     pf=fopen("operazioni.dat","wb");
     if(pf){
            for(i=0;i<n;i++)
               fwrite(&V[i],sizeof(struct operaz),1,pf);
            fclose(pf);
            }
    
     else printf("Errore in scrittura!\n");
     }
     
main(){
       struct operaz O[40];
       int n,scelta;
       
       n=0;
       do{
           printf("\n\nMenu' di Gestione Operazioni Banca online\n\n\t\tPuoi scegliere tra:\n\n");
           printf("1)Lettura da file e copia delle operazioni\n2)Inserimento di una nuova operazione\n3)Cancellazione \n4)Visualizzazione\n5)Salvataggio operazioni\n0)Esci\n\n");
           scanf("%d",&scelta);
           
           switch(scelta){
                          case 1: lettura(O,&n);
                               break;
                         
                          case 2: inserimento(O,&n);
                               break;
                          
                          case 3: cancella(O,&n);
                               break;
                          
                          case 4: visualizza(O,n);
                               break;
                          
                          case 5: salva(O,n);
                               break;
                          
                          default: ;
                          }
           }while(scelta!=0);
       }
